单调栈,多校Ascending Rating

单调栈的作用就是,线性的求出区间最大值,最小值,比如有个长度为100000的序列,问每个连续的长度为10的序列里最小值各是多少。

                           Problem A. Ascending Rating

                    Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
                                   Total Submission(s): 3472    Accepted Submission(s): 1151


 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

 

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD


It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

 

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)


Note that ``⊕'' denotes binary XOR operation.

Sample Input

1 10 6 10 5 5 5 5 3 2 2 1 5 7 6 8 2 9

Sample Output

46 11

Source

2018 Multi-University Training Contest 3

题意:

大意就是求每个固定长度的区间内序列的最大值和最大值更新次数异或上i的总和,分别是A,B

题解;

倒着维护一个单调栈,栈里的元素数量等于count值,栈里严格递增,栈顶最大,不能用STL的dequeue双向队列,也不能用cin,关同步也不行,卡STL就用数组模拟就好,注意两个指针初始值的设置要和后面匹配,memset也不用写,写了超时,控制好头,尾指针即可

代码:

​
#include<bits/stdc++.h>
using namespace std;
long long a[10000002];
long long b[10000002];
int main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(0);
    long long  n,m,k,p,q,r,MOD;
    int t;
    scanf("%d",&t);

    while(t--)
    {
        //cin>>n>>m>>k>>p>>q>>r>>MOD;
        scanf("%lld %lld %lld %lld %lld %lld %lld",&n,&m,&k,&p,&q,&r,&MOD);
        int li=1,ri=1;
        long long A=0,B=0;
        // memset(b,0,sizeof(b));
        for(int i=1; i<=k; i++)
        {
            scanf("%lld",&a[i]);
        }
        for(int i=k+1; i<=n; i++)
        {
            a[i]=(p*a[i-1]+q*i+r)%MOD;

        }
        for(int i=n; i>=1; i--)
        {
            while(li<ri&&a[i]>=a[b[ri]])
            {
                ri--;
            }
            b[++ri]=i;
            if(i+m-1<=n)
            {
                while(b[li+1]>i+m-1)li++;
                A+=(a[b[li+1]]^i);
                B+=((ri-li)^i);
                // cout<<(ri-li+1)<<endl;
            }

        }
        printf("%lld %lld\n",A,B);
    }
}

​

猜你喜欢

转载自blog.csdn.net/wrwhahah/article/details/81318359